org.eclipse.swt.widgets

## Class Button

- java.lang.Object
- - org.eclipse.swt.widgets.Widget
  - - org.eclipse.swt.widgets.Control
    - - org.eclipse.swt.widgets.Button

All Implemented Interfaces:
  Adaptable, Drawable

    public class Button
    extends Control

Instances of this class represent a selectable user interface object that issues notification when pressed and released.

Styles:
  CHECK, PUSH, RADIO, TOGGLE, FLAT, WRAP
  LEFT, RIGHT, CENTER
Events:
  Selection

Note: Only one of the styles ARROW, CHECK, PUSH, RADIO, and TOGGLE may be specified.

Note: Only one of the styles LEFT, RIGHT, and CENTER may be specified.

Note: Only one of the styles UP, DOWN, LEFT, and RIGHT may be specified when the ARROW style is specified.

IMPORTANT: This class is intended to be subclassed only within the SWT implementation.

Since:
  1.0

### Constructor Summary

Constructors
Constructor and Description
`Button(Composite parent, int style)` Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

### Method Summary

Methods
`void` `addSelectionListener(SelectionListener listener)` Adds the listener to the collection of listeners who will be notified when the control is selected, by sending it one of the messages defined in the `SelectionListener` interface.
`Point` `computeSize(int wHint, int hHint, boolean changed)` Returns the preferred size of the receiver.
`<T> T` `getAdapter(java.lang.Class<T> adapter)` Implementation of the `Adaptable` interface.
`int` `getAlignment()` Returns a value which describes the position of the text or image in the receiver.
`boolean` `getGrayed()` Returns `true` if the receiver is grayed, and false otherwise.
`Image` `getImage()` Returns the receiver's image if it has one, or null if it does not.
`boolean` `getSelection()` Returns `true` if the receiver is selected, and false otherwise.
`java.lang.String` `getText()` Returns the receiver's text, which will be an empty string if it has never been set.
`void` `removeSelectionListener(SelectionListener listener)` Removes the listener from the collection of listeners who will be notified when the control is selected.
`void` `setAlignment(int alignment)` Controls how text, images and arrows will be displayed in the receiver.
`void` `setData(java.lang.String key, java.lang.Object value)` Sets the application defined property of the receiver with the specified name to the given value.
`void` `setGrayed(boolean grayed)` Sets the grayed state of the receiver.
`void` `setImage(Image image)` Sets the receiver's image to the argument, which may be `null` indicating that no image should be displayed.
`void` `setSelection(boolean selected)` Sets the selection state of the receiver, if it is of type `CHECK`, `RADIO`, or `TOGGLE`.
`void` `setText(java.lang.String text)` Sets the receiver's text.

### Methods inherited from class org.eclipse.swt.widgets.Control

`addControlListener, addDragDetectListener, addFocusListener, addGestureListener, addHelpListener, addKeyListener, addMenuDetectListener, addMouseListener, addTouchListener, addTraverseListener, computeSize, forceFocus, getAccessible, getBackground, getBackgroundImage, getBorderWidth, getBounds, getCursor, getEnabled, getFont, getForeground, getLayoutData, getLocation, getMenu, getMonitor, getOrientation, getParent, getShell, getSize, getToolTipText, getTouchEnabled, getVisible, isEnabled, isFocusControl, isReparentable, isVisible, moveAbove, moveBelow, pack, pack, redraw, redraw, removeControlListener, removeDragDetectListener, removeFocusListener, removeGestureListener, removeHelpListener, removeKeyListener, removeMenuDetectListener, removeMouseListener, removeTouchListener, removeTraverseListener, requestLayout, setBackground, setBackgroundImage, setBounds, setBounds, setCursor, setEnabled, setFocus, setFont, setForeground, setLayoutData, setLocation, setLocation, setMenu, setOrientation, setParent, setRedraw, setSize, setSize, setToolTipText, setTouchEnabled, setVisible, toControl, toControl, toDisplay, toDisplay, update`

### Methods inherited from class org.eclipse.swt.widgets.Widget

`addDisposeListener, addListener, checkSubclass, checkWidget, dispose, getData, getData, getDisplay, getListeners, getStyle, isDisposed, isListening, notifyListeners, removeDisposeListener, removeListener, removeListener, reskin, setData, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### Button

    public Button(Composite parent,
          int style)

Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

The style value is either one of the style constants defined in class `SWT` which is applicable to instances of this class, or must be built by bitwise OR'ing together (that is, using the `int` "|" operator) two or more of those `SWT` style constants. The class description lists the style constants that are applicable to the class. Style bits are also inherited from superclasses.

Parameters:
  `parent` - a composite control which will be the parent of the new instance (cannot be null)
  `style` - the style of control to construct
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass
See Also:
  `SWT.CHECK`, `SWT.PUSH`, `SWT.RADIO`, `SWT.TOGGLE`, `SWT.FLAT`, `SWT.LEFT`, `SWT.RIGHT`, `SWT.CENTER`, `Widget.checkSubclass()`, `Widget.getStyle()`

### Method Detail

#### setText

    public void setText(java.lang.String text)

Sets the receiver's text.

This method sets the button label. The label may include the mnemonic character but must not contain line delimiters.

Mnemonics are indicated by an '&' that causes the next character to be the mnemonic. When the user presses a key sequence that matches the mnemonic, a selection event occurs. On most platforms, the mnemonic appears underlined but may be emphasised in a platform specific manner. The mnemonic indicator character '&' can be escaped by doubling it in the string, causing a single '&' to be displayed.

Parameters:
  `text` - the new text
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the text is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getText

    public java.lang.String getText()

Returns the receiver's text, which will be an empty string if it has never been set.

Returns:
  the receiver's text
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getSelection

    public boolean getSelection()

Returns `true` if the receiver is selected, and false otherwise.

When the receiver is of type `CHECK` or `RADIO`, it is selected when it is checked. When it is of type `TOGGLE`, it is selected when it is pushed in. If the receiver is of any other type, this method returns false.

Returns:
  the selection state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setSelection

    public void setSelection(boolean selected)

Sets the selection state of the receiver, if it is of type `CHECK`, `RADIO`, or `TOGGLE`.

When the receiver is of type `CHECK` or `RADIO`, it is selected when it is checked. When it is of type `TOGGLE`, it is selected when it is pushed in.

Parameters:
  `selected` - the new selection state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getGrayed

    public boolean getGrayed()

Returns `true` if the receiver is grayed, and false otherwise. When the widget does not have the `CHECK` style, return false.

Returns:
  the grayed state of the checkbox
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  1.2

#### setGrayed

    public void setGrayed(boolean grayed)

Sets the grayed state of the receiver. This state change only applies if the control was created with the SWT.CHECK style.

Parameters:
  `grayed` - the new grayed state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  1.2

#### getImage

    public Image getImage()

Returns the receiver's image if it has one, or null if it does not.

Returns:
  the receiver's image
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setImage

    public void setImage(Image image)

Sets the receiver's image to the argument, which may be `null` indicating that no image should be displayed.

Parameters:
  `image` - the image to display on the receiver (may be `null`)
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_INVALID_ARGUMENT - if the image has been disposed
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getAlignment

    public int getAlignment()

Returns a value which describes the position of the text or image in the receiver. The value will be one of `LEFT`, `RIGHT` or `CENTER` unless the receiver is an `ARROW` button, in which case, the alignment will indicate the direction of the arrow (one of `LEFT`, `RIGHT`, `UP` or `DOWN`)

Returns:
  the alignment
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setAlignment

    public void setAlignment(int alignment)

Controls how text, images and arrows will be displayed in the receiver. The argument should be one of `LEFT`, `RIGHT` or `CENTER` .

Parameters:
  `alignment` - the new alignment
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### computeSize

    public Point computeSize(int wHint,
                    int hHint,
                    boolean changed)

Description copied from class: `Control`
Returns the preferred size of the receiver.

The preferred size of a control is the size that it would best be displayed at. The width hint and height hint arguments allow the caller to ask a control questions such as "Given a particular width, how high does the control need to be to show all of the contents?" To indicate that the caller does not wish to constrain a particular dimension, the constant `SWT.DEFAULT` is passed for the hint.

If the changed flag is `true`, it indicates that the receiver's contents have changed, therefore any caches that a layout manager containing the control may have been keeping need to be flushed. When the control is resized, the changed flag will be `false`, so layout manager caches can be retained.

Overrides:
  `computeSize` in class `Control`
Parameters:
  `wHint` - the width hint (can be `SWT.DEFAULT`)
  `hHint` - the height hint (can be `SWT.DEFAULT`)
  `changed` - `true` if the control's contents have changed, and `false` otherwise
Returns:
  the preferred size of the control.
See Also:
  `Layout`, `Control.getBorderWidth()`, `Control.getBounds()`, `Control.getSize()`, `Control.pack(boolean)`, "computeTrim, getClientArea for controls that implement them"

#### addSelectionListener

    public void addSelectionListener(SelectionListener listener)

Adds the listener to the collection of listeners who will be notified when the control is selected, by sending it one of the messages defined in the `SelectionListener` interface.

`widgetSelected` is called when the control is selected. `widgetDefaultSelected` is not called.

Parameters:
  `listener` - the listener which should be notified
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the listener is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `SelectionListener`, `removeSelectionListener(org.eclipse.swt.events.SelectionListener)`, `SelectionEvent`

#### removeSelectionListener

    public void removeSelectionListener(SelectionListener listener)

Removes the listener from the collection of listeners who will be notified when the control is selected.

Parameters:
  `listener` - the listener which should no longer be notified
Throws:
  `java.lang.IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the listener is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `SelectionListener`, `addSelectionListener(org.eclipse.swt.events.SelectionListener)`

#### setData

    public void setData(java.lang.String key,
               java.lang.Object value)

Description copied from class: `Widget`
Sets the application defined property of the receiver with the specified name to the given value.

Applications may associate arbitrary objects with the receiver in this fashion. If the objects stored in the properties need to be notified when the widget is disposed of, it is the application's responsibility to hook the Dispose event on the widget and do so.

Overrides:
  `setData` in class `Control`
Parameters:
  `key` - the name of the property
  `value` - the new value for the property
See Also:
  `Widget.getData(String)`

#### getAdapter

    public <T> T getAdapter(java.lang.Class<T> adapter)

Description copied from class: `Widget`
Implementation of the `Adaptable` interface.

IMPORTANT: This method is not part of the RWT public API. It is marked public only so that it can be shared within the packages provided by RWT. It should never be accessed from application code.

Specified by:
  `getAdapter` in interface `Adaptable`
Overrides:
  `getAdapter` in class `Control`
Parameters:
  `adapter` - the lookup class
Returns:
  an object that can be cast to the given class or `null` if there is no adapter associated with the given class.

Copyright (c) EclipseSource and others 2002, 2017. All rights reserved. This program and the accompanying materials are made available under the terms of the Eclipse Public License v1.0